var axios = require('axios')
const wx = require('weixin-js-sdk')

function isInWechat() {
  var ua = navigator.userAgent;
  return /MicroMessenger/i.test(ua);
}
//编译打包的时候{{{}}}
//在测试环境下转成相对地址
//在线上环境转成七牛的地址 但是不带有协议头
//将这两种情况都转化成带有协议头的绝对地址
function setImgRemoteUrl (url) {
  if (/^\/\w+/.test(url)) {
    return location.protocol + '//' + location.host + url;
  } else if (/^\/\/\w+/.test(url)) {
    return location.protocol + url;
  }
  return url;
}

function wxready(resourceid='',teacherid='') {
  var jsApiList = [
    'onMenuShareTimeline', //朋友圈分享
    'onMenuShareAppMessage', //分享到朋友
    'hideOptionMenu',//隐藏右上角菜单接口
    'showOptionMenu',//显示右上角菜单接口
    'onMenuShareQQ', //QQ分享
    'onMenuShareQZone', //空间分享
    'chooseImage', //选择照片
    'uploadImage', //上传照片
    'downloadImage', //下载照片
    'previewImage', //预览照片
    'scanQRCode', //扫码
  ];

  var register = function(config, resolve, reject) {
    wx.config({
      debug: false,
      appId: config.appId,
      timestamp: config.timestamp,
      nonceStr: config.nonceStr,
      signature: config.signature,
      jsApiList: jsApiList
    });

    wx.ready(function() {
      resolve(config);
    });

    wx.error(function(error) {
      reject(error);
    });
  };

  var fetchConfig = function(resolve, reject) {
    axios.get('/api/wechat/getConfig', {
        params: {
          url: encodeURIComponent(location.href)
        }
      })
      .then((res) => {
        if (res.status === 200) {
          var config = res.data.data
          resolve(config);
        } else {
          reject(res)
        }
      })
      .catch((error) => {
        reject(error.response);
      })
  }

  return new Promise(function(resolve, reject) {
      //先去获取配置信息
      fetchConfig(resolve, reject);
    }).then(function(config) {
      //验证配置字段信息
      return new Promise(function(resolve, reject) {
        register(config, resolve, reject);
      })
    })
    .catch((error) => {

    })
}

module.exports = {
  isInWechat: isInWechat,
  wxready: wxready,
  setImgRemoteUrl: setImgRemoteUrl
}
