var wxservice = require('./_wxservice.js')
const wx = require('weixin-js-sdk')

/*
params = {
  title: '',
  desc: '',
  imgUrl: '',
  link: '',
  cancelFn: fn,
  successFn: fn,
  wxargument: {
  fuzzy_id: '',
  teacherId: ''
  }
}
*/

function wxSetShare(params) {
  let imgUrl = wxservice.setImgRemoteUrl(params.imgUrl)
  //微信分享配置
  wxservice
    .wxready()
    .then(function() {
      wx.onMenuShareTimeline({
        title: params.title,
        desc: params.desc,
        imgUrl: params.imgUrl,
        link: params.link,
        trigger: function(){
        },
        success: function (res) {
          if(typeof params.successFn === 'function'){
            params.successFn('onMenuShareTimeline')
          }
        },
        cancel: function (res) {
          if(typeof params.cancelFn === 'function'){
            params.cancelFn('onMenuShareTimeline')
          }
        },
        fail: function (res) {
          alert(JSON.stringify(res));
        }
      })

      wx.onMenuShareAppMessage({
        title: params.title,
        desc: params.desc,
        imgUrl: params.imgUrl,
        link: params.link,
        trigger: function(){
        },
        success: function (res) {
          if(typeof params.successFn === 'function'){
            params.successFn('onMenuShareAppMessage')
          }
        },
        cancel: function (res) {
          if(typeof params.cancelFn === 'function'){
            params.cancelFn('onMenuShareAppMessage')
          }
        },
        fail: function (res) {
          alert(JSON.stringify(res));
        }
      })

      wx.onMenuShareQQ({
        title: params.title,
        desc: params.desc,
        imgUrl: params.imgUrl,
        link: params.link,
        trigger: function(){
        },
        success: function (res) {
        },
        cancel: function (res) {
        },
        fail: function (res) {
          alert(JSON.stringify(res));
        }
      })

      wx.showOptionMenu()
    },function(){})
}

function setHideMenu(){
  wxservice
    .wxready('','')
    .then(function() {
      wx.hideOptionMenu()
    },function(){})
}

function wxReadyCallback(fn){
  if(typeof fn === 'function'){
    wxservice
      .wxready()
      .then(fn())
  }else{
    alert(`${fn} is not function`)
  }
}

module.exports = {
  wxSetShare: wxSetShare,
  setHideMenu: setHideMenu,
  wxReadyCallback: wxReadyCallback
}
